"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const HTMLElement_class_1 = require("./HTMLElement.class");
const HTMLTemplateElement_class_1 = require("./HTMLTemplateElement.class");
class xjs_HTMLTableRowElement extends HTMLElement_class_1.default {
    constructor(node) {
        super(node);
    }
    get node() { return super.node; }
    populate(renderer, dataset, options = {}, this_arg = this) {
        let template = this.node.querySelector('template');
        if (template === null) {
            throw new ReferenceError('This <tr> does not have a <template> descendant.');
        }
        if (template.content.children.length !== 1 || !template.content.children[0].matches('td')) {
            throw new ReferenceError('The <template> must contain exactly 1 element, which must be a <td>.');
        }
        let component = new HTMLTemplateElement_class_1.default(template);
        return this.append(...dataset.map((data) => component.render(renderer, data, options, this_arg)));
    }
}
exports.default = xjs_HTMLTableRowElement;
